/*
*	SmallBasic keywords
*	keyword byte-code size = 1 byte = 255 names + kwNULL
*
*	Nikos Christopoulos
*/

#if !defined(_sb_kw_h)
#define _sb_kw_h

#if defined(__cplusplus)
extern "C" {
#endif

#define	OPLOG_GT	'>'
#define	OPLOG_LT	'<'
#define	OPLOG_EQ	'='
#define	OPLOG_GE	11		// >=
#define	OPLOG_LE	12		// <=
#define	OPLOG_NE	14		// <>
#define	OPLOG_AND	'&'		// AND
#define	OPLOG_OR	'|'		// OR
#define	OPLOG_NOT	'!'		// NOT
#define	OPLOG_XOR	'~'		// XOR

enum keyword	{
kwTYPE_INT,				/* 32b Integer */
kwTYPE_NUM,				/* 64b Real */
kwTYPE_STR,				/* String */
kwTYPE_LOGOPR,			/* Logical operator */
kwTYPE_CMPOPR,			/* Comparation operator */
kwTYPE_ADDOPR,			/* ADD/SUB operator */
kwTYPE_MULOPR,			/* MUL/DIV/IDIV operator */
kwTYPE_POWOPR,			/* POW(x,y) operator */
kwTYPE_UNROPR,			/* Unary operator */
kwTYPE_VAR,				/* Variable */
kwTYPE_SEP,				/* Separator */
kwTYPE_LINE,			/* Debug info: SOURCE LINE */
kwTYPE_LEVEL_BEGIN,		/* Parenthesis ( */
kwTYPE_LEVEL_END,		/* Parenthesis ) */
kwTYPE_EOC,				/* End-Of-Command mark */
kwTYPE_EVPUSH,			/* PUSH R */
kwTYPE_EVPOP,			/* POP  L */
kwTYPE_CALL_UDF,		/* Call user defined function */		
kwTYPE_CALL_UDP,		/* Call user defined procedure */
kwTYPE_CRVAR,			/* Create dynamic variable (PARAMETERS OR LOCALS) */
kwTYPE_RET,				/* Return from UDF|UDP */
kwTYPE_PARAM,			/* Parameters */
kwLOCAL,				/* Create local variables */
kwFUNC,					/* USER DEFINED FUNCTION */
kwPROC,					/* USER DEFINED PROCEDURE */
kwBYREF,
kwDECLARE,

kwLET,
kwCONST,
kwEND,
kwSTOP,
kwPRINT,
kwINPUT,
kwCLS,
kwREM,
kwLABEL,
kwGOTO,
kwIF,
kwTHEN,
kwELSE,
kwELIF,
kwENDIF,
kwFOR,
kwTO,				
kwSTEP,
kwNEXT,
kwWHILE,
kwWEND,
kwREPEAT,
kwUNTIL,
kwGOSUB,
kwRETURN,
kwEXIT,
kwLOOP,

kwDIM,
kwTYPE,
kwCHAIN,
kwREAD,
kwDATA,
kwRESTORE,			
kwSHELL,

/* console */
kwINKEY,
kwLOCATE,
kwAT,
kwPEN,

/* ... */
kwRND,
kwABS,
kwLEN,
kwCOS,
kwSIN,
kwTAN,
kwACOS,
kwASIN,
kwATAN,
kwACOSH,
kwASINH,
kwATANH,
kwCOSH,
kwSINH,
kwTANH,
kwEXP,
kwLOG,
kwLOG10,
kwSQR,
kwINT,
kwCINT,
kwCDBL,
kwFIX,
kwSGN,
kwASC,
kwCHR,
kwHEX,
kwOCT,
kwBIN,
kwSTR,
kwVAL,
kwLCASE,
kwUCASE,
kwLTRIM,
kwRTRIM,
kwSTRING,
kwTICKS,
kwTICKSPERSEC,
kwFRE,
kwBEEP,
kwSOUND,
kwPSET,
kwLINE,
kwRECT,
kwCIRCLE,
kwCOLOR,
kwFILLED,
kwRANDOMIZE,
kwINSTR,
kwLEFT,
kwRIGHT,
kwMID,
kwSPACE,
kwATAN2,
kwPOW,
kwROUND,
kwDEG,
kwRAD,
kwLBOUND,
kwUBOUND,
kwTIME,
kwTIMER,
kwDATE,
kwON,
kwOFF,
kwWSPLIT,
kwPAUSE,
kwTRON,
kwTROFF,
kwTAB,
kwCAT,
kwONJMP,
kwDELAY,
kwARC,
kwDRAW,
kwPLAY,
kwRUN,
kwTEXTWIDTH,
kwTEXTHEIGHT,
kwCHART,
kwMAX,
kwMIN,
kwDRAWPOLY,
kwERASE,

kwFREEFILE,
kwOPEN,
kwFORSEP,
kwINPUTSEP,
kwOUTPUT,
kwAPPEND,
kwAS,
kwCLOSE,
kwFILEPRINT,
kwLINEINPUT,
kwFILEINPUT,
kwEOF,
kwKILL,
kwEXIST,
kwSEEK,
kwLOF,
kwRENAME,
kwCOPY,
/* file 
kwGET,
kwPUT,
*/
kwLOGPRINT,

#ifdef BC_DEBUG
kwBCDUMP,
kwSTKDUMP,
#endif

kwNULL
};

#if defined(__cplusplus)
}
#endif

#endif

